Subject: bug#468: python platform.linux_distribution() returns debian

From: Mark Hindley <[email-masked]>
Date: Fri, 22 May 2020 12:49:17 +0100

Peter,

On Fri, May 22, 2020 at 12:21:01PM +0100, Peter Duffy wrote:
> Hi Mark,
> 
> Thanks for getting back to me. I agree that this is problematic, and I
> concur with your points and decision not to fix.

I will leave this open, in case any better suggestions come along.

> As I mentioned, I came up against this whilst trying to fix waagent (aka
> walinuxagent and azurelinuxagent) - the glue layer which the Microsoft
> Azure front-end uses to communicate with linux running on VMs. I'm
> trying to set up a virtualbox VM based on devuan ascii, for use as a
> base OS image in Azure. At the moment, waagent detects the system as
> debian instead of devuan, and so tries to use systemd-based utilities
> and functions: of course, these aren't present, so waagent doesn't work
> under devuan. (I'm not sure that it's worth flagging it up as a bug in
> the waagent package? OK, the problem is specific to devuan, but it needs
> to be fixed in waagent.)

Yes, please do.  Let me know if there is anything I can do to help.

It is also worth noting that this approach will sometimes be broken in Debian
too: non-systemd init is still possible in all Debian suites. I suggest it would
be better if they detected init system and acted on that rather than inferred
the init from the distribution. 

> BTW - one point of order. The utility is /usr/bin/lsb_release - the file
> that platform.linux_distribution() tries to use is /etc/lsb-release.
> Don't ask me why :(

Absolutely -- thanks for correcting my lazy typing!

Mark